<?php 
/*** Options Framework ***/
require_once get_template_directory().'/admin/index.php';

/*** Include Framework File ***/
require_once get_template_directory().'/framework/init.php';

function ocdi_import_files() {
    return array(
        array(
            'import_file_name'             => 'Demo Import 1',
            'categories'                   => array( 'Category 1', 'Category 2' ),
            'local_import_file'            => trailingslashit( get_template_directory() ) . 'moye/content.xml',
            // 'local_import_file'            => trailingslashit( get_template_directory() ) . 'moye/temp.xml',
            'local_import_widget_file'     => trailingslashit( get_template_directory() ) . 'moye/widgets.json',
            'local_import_redux'           => array(
                array(
                    'file_path'   => trailingslashit( get_template_directory() ) . 'moye/redux.json',
                    'option_name' => 'gon_opt',
                ),
            ),
            'import_preview_image_url'     => trailingslashit( get_template_directory() ) . 'ocdi/screen-image.jpg',
            'import_notice'                => 'نصب کننده قالب gon به صورت اتوماتیک.نصب درون ریز ممکن است زمان بر باشد . کمی صبر کنید<br/>این قالب توسط ووکامرس فارسی عرضه شده است. درخواست پشتیبانی: http://support.woocommerce.ir',
        )
    );
}
add_filter( 'pt-ocdi/import_files', 'ocdi_import_files' );

function ocdi_after_import_setup() {
    // Assign menus to their locations.
    $primary = get_term_by( 'name', 'main menu', 'nav_menu' );
    $vertical = get_term_by( 'name', 'دسته ها', 'nav_menu' );
    $mobile = get_term_by( 'name', 'mobile menu', 'nav_menu' );

    set_theme_mod( 'nav_menu_locations', array(
            'primary' => $primary->term_id,
            'vertical' => $vertical->term_id,
            'mobile' => $mobile->term_id,
        )
    );

    // Assign front page and posts page (blog page).
    $front_page_id = get_page_by_title( 'خانه' );
    $blog_page_id  = get_page_by_title( 'وبلاگ' );

    update_option( 'show_on_front', 'page' );
    update_option( 'page_on_front', $front_page_id->ID );
    update_option( 'page_for_posts', $blog_page_id->ID );
    
    if ( class_exists( 'RevSlider' ) ) {
           $slider_array = array(
              get_template_directory()."/moye/classic-box.zip",
              get_template_directory()."/moye/fullwidth parallax.zip",
              get_template_directory()."/moye/home-catalog.zip",
              get_template_directory()."/moye/home-main.zip",
              get_template_directory()."/moye/home-sidebar.zip",
              get_template_directory()."/moye/home-supermarket.zip",
              get_template_directory()."/moye/home-supermarket-2.zip",
              get_template_directory()."/moye/home-supermarket-3.zip",
              get_template_directory()."/moye/special-collection.zip",
              );
 
           $slider = new RevSlider();
        
           foreach($slider_array as $filepath){
             $slider->importSliderFromPost(true,true,$filepath);  
           }
        
           echo ' Slider processed';
      }

}
add_action( 'pt-ocdi/after_import', 'ocdi_after_import_setup' );

?>